// The initial version of this file was autogenerated from the official AS3 reference at 
// https://help.adobe.com/en_US/FlashPlatform/reference/actionscript/3/flash/events/StageVideoEvent.html
// by https://github.com/golfinq/ActionScript_Event_Builder
// It won't be regenerated in the future, so feel free to edit and/or fix
package flash.events
{
    
    // According to the AS3 docs, this class is only available starting with Flash Player 10.2,
    // and some members of it are AIR-only. This is yet another case of misdocumentation.
    [API("667")]
    public class StageVideoEvent extends Event
    {
        // The StageVideoEvent.RENDER_STATE constant defines the value of the type property of a renderState event object.
        public static const RENDER_STATE:String = "renderState";

        // Indicates that hardware is decoding and displaying the video.
        // Deprecated since Flash Player 10.2, AIR 3: Please Use flash.media.VideoStatus.ACCELERATED
        public static const RENDER_STATUS_ACCELERATED : String = "accelerated";

        // Indicates that software is decoding and displaying the video.
        // Deprecated since Flash Player 10.2, AIR 3: Please Use flash.media.VideoStatus.SOFTWARE
        public static const RENDER_STATUS_SOFTWARE : String = "software";

        // Indicates that displaying the video using the StageVideo object is not possible.
        // Deprecated since Flash Player 10.2, AIR 3: Please Use flash.media.VideoStatus.UNAVAILABLE
        public static const RENDER_STATUS_UNAVAILABLE : String = "unavailable";


        public const codecInfo:String;

        private var _status: String; // The status of the StageVideo object.
        private var _colorSpace: String; // The color space used by the video being displayed in the StageVideo object.

        public function StageVideoEvent(type:String, bubbles:Boolean = false, cancelable:Boolean = false, status:String = null, colorSpace:String = null)
        {
            super(type,bubbles,cancelable);
            this._status = status;
            this._colorSpace = colorSpace;
        }
        

        public function get status() : String
        {
            return this._status;
        }
        

        public function get colorSpace() : String
        {
            return this._colorSpace;
        }
        
    }
}

